-- Gfx version 1.0
-- By Pizzasgood (Rin Ganborro)
-- This software is released under the WTFPL Version 2 (http://sam.zoy.org/wtfpl/COPYING)
-- (In short:  Do whatever you want with it.)

Gfx = {}
Gfx.old_background = nil
Gfx.old_junk = nil

local background_index = 1
local junk_index = 3
local max_background = 7
local max_junk = 4

function Gfx.get_array()
	local current = gkinterface.GetGraphicsOptions()
	local ret = {}
	for i,v in pairs(current) do
		ret[i] = v.value
	end
	return(ret)
end


function Gfx.black()
	local current = Gfx.get_array()
	if Gfx.old_background ~= 1 then
		Gfx.old_background = current[background_index]
	end
	if Gfx.old_junk ~= 1 then
		Gfx.old_junk = current[junk_index]
	end
	current[background_index] = 1
	current[junk_index] = 1
	gkinterface.SetGraphicsOptions(current)
end


function Gfx.unblack()
	local current = Gfx.get_array()
	if Gfx.old_background ~= nil and Gfx.old_background ~= 1 then
		current[background_index] = Gfx.old_background
	else
		current[background_index] = max_background
	end
	if Gfx.old_junk ~= nil and Gfx.old_junk ~= 1 then
		current[junk_index] = Gfx.old_junk
	else
		current[junk_index] = max_junk
	end
	gkinterface.SetGraphicsOptions(current)
end


function Gfx.toggle()
	
	if gkinterface.GetGraphicsOptions()[background_index].value == 1 then
		Gfx.unblack()
	else
		Gfx.black()
	end
end


function Gfx.help()
	local color = "\127D0D0D0"
	print(color.."/Gfx help")
	print(color.."/Gfx black | unblack | toggle")
	print(color.."All options can be used via their first letter as well, e.g. '/set b' to black.  If no option is given, it toggles.")
end

function Gfx.process(_,data)
	if (data ~= nil and (data[1] == "black" or data[1] == "b")) then
		Gfx.black()
	elseif (data ~= nil and (data[1] == "unblack" or data[1] == "u")) then
		Gfx.unblack()
	elseif (data == nil or (data ~= nil and (data[1] == "toggle" or data[1] == "t"))) then
		Gfx.toggle()
	elseif (data ~= nil and (data[1] == "help" or data[1] == "h")) then
		Gfx.help()
	else
		Gfx.help()
	end
end

RegisterUserCommand("gfx", Gfx.process)